require "/scripts/companions/recruitable.lua"
require "/scripts/messageutil.lua"

function init()
  self.offerType = config.getParameter("offerType")
  self.messages = root.assetJson(config.getParameter("merchant.dialog", "/items/active/unsorted/joboffers/joboffers.config"))
end

local isActionOver = false

function update(dt, fireMode, shiftHeld)
  promises:update()
  if fireMode ~= "none" then
    if not isActionOver then
      fire()
      isActionOver = true
    end
  else
    isActionOver = false
  end
end

function fire()
  npcs = world.entityQuery(activeItem.ownerAimPosition(), 3, {includedTypes={"npc"}, order="nearest"})
  if npcs[1] then
    promise = world.sendEntityMessage(npcs[1], "makeRecruitable", {offerType = self.offerType, messages = self.messages})
    promises:add(promise, success, failure)
  end
end

function success(npcId)
  if npcId then
    world.sendEntityMessage(npcId, "saySomething", {messages = self.messages, message = "jobOfferSuccess"})
    item.setCount(0)
  end
end

function failure(error)
  sb.logInfo("failure")
  sb.logInfo(error)
  status.setStatusProperty( "jobOffersError", 1)
end